Subject: Access roles are not inherited

Description

Assuming, we defined the following three ACL roles in Policy.yaml:

- administrator
- manager
- auditor

"Auditor" should be the lowest level, "administrator" the highest. A typical example would be: admin has access to everything (incl.
user management features), "manager" and "auditor" have access to low level features. Therefore, a good approach would be to
inherit all privileges an "auditor" has, to the "manager" role and all privileges a "manager" has, to "administrator".

The attached document shows the entries in "Policy.yaml" as an example. Note the two/four lines highlighted in red (at "acl" section).
You would expect that you do NOT need those lines, because "manager"” already has access to Meter/Asset (inherited by "auditor"),

as well as "administrator".

But if these lines are removed, an "Access denied" exception is thrown when trying to access Asset/Meters with a "manager” or
"administrator" user.

Assumption:

Privileges are not inherited. In this example: GRANT for role "auditor" is not passed to "manager" (and "administrator" in the next
level).

Workaround:

Assign all "admin" users to "auditor" and/or "manager” roles, too. Or: include the additional lines in Policy.yaml as shown in attached
document.

Associated revisions

Revision 45567307 - 2010-06-24 14:54 - Andreas Forthner

- [+BUGFIX] FLOWS (Security): Inheritance of roles works now again. Fixes #8427.
- [~TASK] FLOWS3 (Security): Added a safeguard to catch syntax errors when loading the policy configuration.

History

#1 - 2010-06-22 02:50 - Michael Schams
- File issue8427-FLOWS3-policy-issue.pdf added

#2 - 2010-06-23 15:16 - Karsten Dambekalns
- Project changed from Core Team to TYPOGS.Flow

#3 - 2010-06-23 15:19 - Andreas Férthner
- Category set to Security

- Status changed from New to Accepted

- Assigned To set to Andreas Férthner

This feature got probably lost in the last refactoring of the security context. The getRoles() method of the context has to take inheritance into account.

| will take care asap.

#4 - 2010-06-24 15:00 - Andreas Férthner
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r4624.

#5 - 2010-07-15 13:36 - Karsten Dambekalns

- Target version set to 1.0 alpha 10
